Index: trunk/LMDZ.TITAN/libf/phytitan/write_histmth.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/write_histmth.h	(revision 1055)
+++ trunk/LMDZ.TITAN/libf/phytitan/write_histmth.h	(revision 1056)
@@ -1,121 +1,72 @@
       IF (ok_mensuel) THEN
-c
-      ndex2d = 0
-      ndex3d = 0
-      zx_tmp_2d = 0.
-      zx_tmp_3d = 0.
-      zx_tmp_fi2d=0.
-      zx_tmp_fi3d=0.
-c
+
          zsto = dtime
-         zout = dtime * FLOAT(ecrit_mth)
+         zout = dtime * REAL(ecrit_mth)
          itau_w = itau_phy + itap
-c
+
 c-------------------------------------------------------
       IF(lev_histmth.GE.1) THEN
-c
+
 ccccccccccccc 2D fields, invariables
-c
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,pphis,zx_tmp_2d)
-      CALL histwrite(nid_mth,"phis",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-C
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
-      CALL histwrite(nid_mth,"aire",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"phis",itau_w,pphis)
+      call histwrite_phy(nid_mth,.false.,"aire",itau_w,airephy)
+
 ccccccc axe Ls ... Faudrait le reduire a axe temporel seulement...
-      do j=1,jjmp1
-       do i=1,iim
-        zx_tmp_2d(i,j)=zls*180./RPI      ! zls est en radians !!
-       enddo
-      enddo
-c Correction passage de 360 à 0... Sinon probleme avec moyenne
+c Correction passage de 360 a 0... Sinon probleme avec moyenne
       if (zls.lt.zlsm1) then
-        zx_tmp_2d = zx_tmp_2d+360.
+        do i=1,klon
+          tmpout(i,1) = zls*180./RPI+360.
+        enddo
         zlsm1 = 2.*RPI
       else
+        do i=1,klon
+          tmpout(i,1) = zls*180./RPI
+        enddo
         zlsm1 = zls
       endif
-      CALL histwrite(nid_mth,"ls",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+      call histwrite_phy(nid_mth,.false.,"ls",itau_w,tmpout(:,1))
+
 ccccccccccccc 2D fields, variables
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ftsol,zx_tmp_2d)
-      CALL histwrite(nid_mth,"tsol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      DO i = 1, klon
-         zx_tmp_fi2d(i) = paprs(i,1)
-      ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_mth,"psol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ue,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"ue",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ve,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"ve",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"cdragh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"cdragm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"tsol",itau_w,ftsol)
+      call histwrite_phy(nid_mth,.false.,"psol",itau_w,paprs(:,1))
+
+c     call histwrite_phy(nid_mth,.false.,"ue",itau_w,ue)
+c     call histwrite_phy(nid_mth,.false.,"ve",itau_w,ve)
+
       ENDIF !lev_histmth.GE.1
-c
+
 c-------------------------------------------------------
       IF(lev_histmth.GE.2) THEN
-c
+
 ccccccccccccc 3D fields, basics
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, t_seri, zx_tmp_3d)
-      CALL histwrite(nid_mth,"temp",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, pplay, zx_tmp_3d)
-      CALL histwrite(nid_mth,"pres",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, zphi, zx_tmp_3d)
-      CALL histwrite(nid_mth,"geop",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, u_seri, zx_tmp_3d)
-      CALL histwrite(nid_mth,"vitu",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, v_seri, zx_tmp_3d)
-      CALL histwrite(nid_mth,"vitv",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, omega, zx_tmp_3d)
-      CALL histwrite(nid_mth,"vitw",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, ycoefh, zx_tmp_3d)
-c     CALL histwrite(nid_mth,"Kz",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, topsw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"tops",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"temp",itau_w,t_seri)
+      call histwrite_phy(nid_mth,.false.,"pres",itau_w,pplay)
+      call histwrite_phy(nid_mth,.false.,"geop",itau_w,zphi)
+      call histwrite_phy(nid_mth,.false.,"vitu",itau_w,u_seri)
+      call histwrite_phy(nid_mth,.false.,"vitv",itau_w,v_seri)
+      call histwrite_phy(nid_mth,.false.,"vitw",itau_w,omega)
+c      call histwrite_phy(nid_mth,.false.,"Kz",itau_w,ycoefh)
+      call histwrite_phy(nid_mth,.false.,"tops",itau_w,topsw)
+      call histwrite_phy(nid_mth,.false.,"duvdf",itau_w,d_u_vdf)
+      call histwrite_phy(nid_mth,.false.,"dudyn",itau_w,d_u_dyn)
+
 cccccccccccccccccc  Tracers
-c
+
          if (iflag_trac.eq.1) THEN
           if (microfi.ge.1) then
 c          DO iq=1,nmicro
-c      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, 
-c    .                  qaer(1:klon,1:klev,iq), zx_tmp_3d)
-c      CALL histwrite(nid_mth,tname(iq),itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
+c      call histwrite_phy(nid_mth,.false.,tname(iq),
+c    .                    itau_w,qaer(1:klon,1:klev,iq))
 c          ENDDO
 c    -------   NB AER TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,1:nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_mth,"qaer",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,1:nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_mth,.false.,"qaer",itau_w,tmpout)
 
              if (clouds.eq.1) then
@@ -123,174 +74,121 @@
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,nrad+1:2*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_mth,"qnoy",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,nrad+1:2*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_mth,.false.,"qnoy",itau_w,tmpout)
 c    -------   V GLA1 TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,2*nrad+1:3*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_mth,"qgl1",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,2*nrad+1:3*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_mth,.false.,"qgl1",itau_w,tmpout)
 c    -------   V GLA2 TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,3*nrad+1:4*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_mth,"qgl2",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,3*nrad+1:4*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_mth,.false.,"qgl2",itau_w,tmpout)
 c    -------   V GLA3 TOT
                do i=1,klon
                  do j=1,klev
-                   zx_tmp_fi3d(i,j)= SUM(qaer(i,j,4*nrad+1:5*nrad))
-                 enddo
-               enddo
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-       CALL histwrite(nid_mth,"qgl3",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+                   tmpout(i,j)= SUM(qaer(i,j,4*nrad+1:5*nrad))
+                 enddo
+               enddo
+       call histwrite_phy(nid_mth,.false.,"qgl3",itau_w,tmpout)
 c --------------
 c ----- SATURATION ESP NUAGES
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satch4,zx_tmp_3d)
-       CALL histwrite(nid_mth,"ch4sat", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satc2h6,zx_tmp_3d)
-       CALL histwrite(nid_mth,"c2h6sat", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, satc2h2,zx_tmp_3d)
-       CALL histwrite(nid_mth,"c2h2sat", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_mth,.false.,"ch4sat",itau_w,satch4)
+       call histwrite_phy(nid_mth,.false.,"c2h6sat",itau_w,satc2h6)
+       call histwrite_phy(nid_mth,.false.,"c2h2sat",itau_w,satc2h2)
 c --------------
 c ----- RESERVOIR DE SURFACE
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,reservoir,zx_tmp_2d)
-       CALL histwrite(nid_mth,"reserv",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_mth,.false.,"reserv",itau_w,reservoir)
 c --------------
 c ----- ECHANGE GAZ SURF/ATM (evaporation)
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,evapch4,zx_tmp_2d)
-       CALL histwrite(nid_mth,"evapch4",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_mth,.false.,"evapch4",itau_w,evapch4)
 c --------------
 c ----- PRECIPITATIONS
 c       -----  CH4
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,1),zx_tmp_2d)
-       CALL histwrite(nid_mth,"prech4",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_mth,.false.,"prech4",
+     .            itau_w,precip(1:klon,1))
 c       -----  C2H6
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,2),zx_tmp_2d)
-       CALL histwrite(nid_mth,"prec2h6",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_mth,.false.,"prec2h6",
+     .            itau_w,precip(1:klon,2))
 c       -----  C2H2
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,3),zx_tmp_2d)
-       CALL histwrite(nid_mth,"prec2h2",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
-c
+       call histwrite_phy(nid_mth,.false.,"prec2h2",
+     .            itau_w,precip(1:klon,3))
 c       -----  NOY
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,4),zx_tmp_2d)
-       CALL histwrite(nid_mth,"prenoy",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_mth,.false.,"prenoy",
+     .            itau_w,precip(1:klon,4))
 c       -----  AER
-       CALL gr_fi_ecrit(1, klon,iim,jjmp1,precip(1:klon,5),zx_tmp_2d)
-       CALL histwrite(nid_mth,"preaer",itau_w,zx_tmp_2d,
-     .                        iim*jjmp1,ndex2d)
+       call histwrite_phy(nid_mth,.false.,"preaer",
+     .            itau_w,precip(1:klon,5))
 c --------------
 c ----- FLUX GLACE
 c       -----  CH4
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .                  flxesp_i(1:klon,1:klev,1),zx_tmp_3d)
-       CALL histwrite(nid_mth,"flxgl1", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_mth,.false.,"flxgl1",
+     .            itau_w,flxesp_i(1:klon,1:klev,1))
 c       -----  C2H6
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .                  flxesp_i(1:klon,1:klev,2),zx_tmp_3d)
-       CALL histwrite(nid_mth,"flxgl2", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_mth,.false.,"flxgl2",
+     .            itau_w,flxesp_i(1:klon,1:klev,2))
 c       -----  C2H2
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .                  flxesp_i(1:klon,1:klev,3),zx_tmp_3d)
-       CALL histwrite(nid_mth,"flxgl3", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_mth,.false.,"flxgl3",
+     .            itau_w,flxesp_i(1:klon,1:klev,3))
 c --------------
 c ----- Source/puits GLACE
 c       -----  CH4
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .                          solesp(1:klon,1:klev,1),zx_tmp_3d)
-       CALL histwrite(nid_mth,"solch4", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_mth,.false.,"solch4",
+     .            itau_w,solesp(1:klon,1:klev,1))
 c       -----  C2H6
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .                          solesp(1:klon,1:klev,2),zx_tmp_3d)
-       CALL histwrite(nid_mth,"solc2h6", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_mth,.false.,"solc2h6",
+     .            itau_w,solesp(1:klon,1:klev,2))
 c       -----  C2H2
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,
-     .                          solesp(1:klon,1:klev,3),zx_tmp_3d)
-       CALL histwrite(nid_mth,"solc2h2", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+       call histwrite_phy(nid_mth,.false.,"solc2h2",
+     .            itau_w,solesp(1:klon,1:klev,3))
 c --------------
 c ----- RAYON MOYEN GOUTTE
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, rmcloud,zx_tmp_3d)
-       CALL histwrite(nid_mth,"rcldbar", itau_w, zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+       call histwrite_phy(nid_mth,.false.,"rcldbar",itau_w,rmcloud)
+
              endif
 	  endif
-c
+
 c --------------
 c ----- TRACEURS CHIMIQUES
           if (nmicro.lt.nqmax) then
            DO iq=nmicro+1,nqmax
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1,tr_seri(1,1,iq),zx_tmp_3d)
-       CALL histwrite(nid_mth,tname(iq),itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+       call histwrite_phy(nid_mth,.false.,tname(iq),
+     .                    itau_w,tr_seri(1:klon,1:klev,iq))
            ENDDO
 c Condensation:
 c          DO iq=nmicro+1,nqmax
-c      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,d_tr_mph(1,1,iq),zx_tmp_3d)
-c      CALL histwrite(nid_mth,"c_"//tname(iq),itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
+c      call histwrite_phy(nid_mth,.false.,"c_"//tname(iq),
+c    .                    itau_w,d_tr_mph(1:klon,1:klev,iq))
 c          ENDDO
 	  endif
          endif
-c
+
       ENDIF !lev_histmth.GE.2
-c
+
 c-------------------------------------------------------
       IF(lev_histmth.GE.3) THEN
-c
+
 cccccccccccccccccc  Radiative transfer
-c
+
 c 2D
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, toplw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"topl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, solsw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"sols",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"soll",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"topl",itau_w,toplw)
+      call histwrite_phy(nid_mth,.false.,"sols",itau_w,solsw)
+      call histwrite_phy(nid_mth,.false.,"soll",itau_w,sollw)
+
 c 3D
-c
-      zx_tmp_fi3d(1:klon,1:klev)=swnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"SWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=lwnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"LWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"SWnet",
+     .          itau_w,swnet(1:klon,1:klev))
+      call histwrite_phy(nid_mth,.false.,"LWnet",
+     .          itau_w,lwnet(1:klon,1:klev))
+
 c --------------
 c ----- OPACITE BRUME
@@ -301,9 +199,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"thv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"thv"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECV 
 
@@ -314,11 +209,7 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"thi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"thi"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECI 
-c
 c --------------
 c ----- EXTINCTION BRUME
@@ -335,9 +226,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"khv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"khv"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECV 
 
@@ -354,11 +242,7 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"khi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"khi"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECI 
-c
 c --------------
 c ----- OPACITE GAZ
@@ -369,9 +253,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"tgv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"tgv"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECV 
 
@@ -382,11 +263,7 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_tauhvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"tgi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"tgi"//str2,itau_w,t_tauhvd)
        enddo      ! fin boucle NSPECI 
-c
 c --------------
 c ----- EXTINCTION GAZ
@@ -403,9 +280,6 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"kgv"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"kgv"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECV 
 
@@ -423,18 +297,13 @@
          enddo
          enddo
-         write(str1,'(i2.2)') k
-      zx_tmp_fi3d(1:klon,1:klev)=t_khvd(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"kgi"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         write(str2,'(i2.2)') k
+       call histwrite_phy(nid_mth,.false.,"kgi"//str2,itau_w,t_khvd)
        enddo      ! fin boucle NSPECI 
 
 c --------------
+         if (clouds.eq.1) then
+c --------------
 c ----- OPACITE NUAGES (ATTENTION PROXY)
-         if (clouds.eq.1) then
-           zx_tmp_fi3d(1:klon,1:klev)=occcld(1:klon,1:klev)
-           CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-           CALL histwrite(nid_mth,"tcld",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+         call histwrite_phy(nid_mth,.false.,"tcld",itau_w,occcld)
 c --------------
 c ----- EXTINCTION NUAGES (ATTENTION PROXY)
@@ -447,97 +316,48 @@
              enddo
            enddo
-           zx_tmp_fi3d(1:klon,1:klev)=t_kcld(1:klon,1:klev)
-           CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-           CALL histwrite(nid_mth,"kcld",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+         call histwrite_phy(nid_mth,.false.,"kcld",itau_w,t_kcld)
 c --------------
 c ----- OCCURENCE NUAGES
            do k=1,12
-             write(str1,'(i2.2)') k
-             zx_tmp_fi3d(1:klon,1:klev)=occcld_m(1:klon,1:klev,k)
-             CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-             CALL histwrite(nid_mth,"occcld"//str1,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+             write(str2,'(i2.2)') k
+        call histwrite_phy(nid_mth,.false.,"occcld"//str2,
+     .          itau_w,occcld_m(1:klon,1:klev,k))
            enddo
-c
+c --------------
         endif  
-c
+c --------------
+
       ENDIF !lev_histmth.GE.3
-c
+
 c-------------------------------------------------------
       IF(lev_histmth.GE.4) THEN
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t_dyn, zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtdyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t, zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtphy",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+
+      call histwrite_phy(nid_mth,.false.,"dtdyn",itau_w,d_t_dyn)
+      call histwrite_phy(nid_mth,.false.,"dtphy",itau_w,d_t)
 c K/s
-      zx_tmp_fi3d(1:klon,1:klev)=d_t_vdf(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dtvdf",itau_w,d_t_vdf)
 c K/s
-      zx_tmp_fi3d(1:klon,1:klev)=d_t_ajs(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dtajs",itau_w,d_t_ajs)
 c K/s
-      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtswr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dtswr",itau_w,heat)
+c K/s
+      call histwrite_phy(nid_mth,.false.,"dtlwr",itau_w,-1.*cool)
 c K/s      
-      zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtlwr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c K/s      
-c     zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-c     CALL histwrite(nid_mth,"dtec",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_vdf, zx_tmp_3d)
-      CALL histwrite(nid_mth,"duvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_dyn, zx_tmp_3d)
-      CALL histwrite(nid_mth,"dudyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_v_vdf, zx_tmp_3d)
-c     CALL histwrite(nid_mth,"dvvdf",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c      call histwrite_phy(nid_mth,.false.,"dtec",itau_w,d_t_ec)
+c      call histwrite_phy(nid_mth,.false.,"dvvdf",itau_w,d_v_vdf)
+
       ENDIF !lev_histmth.GE.4
 c
 c-------------------------------------------------------
       IF(lev_histmth.GE.5) THEN
-c
-c
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxu , zx_tmp_2d)
-c      CALL histwrite(nid_mth,"taux_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d) 
-c      
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxv , zx_tmp_2d)
-c      CALL histwrite(nid_mth,"tauy_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"cdrm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"cdrh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+c      call histwrite_phy(nid_mth,.false.,"taux",itau_w,fluxu)
+c      call histwrite_phy(nid_mth,.false.,"tauy",itau_w,fluxv)
+c      call histwrite_phy(nid_mth,.false.,"cdrm",itau_w,cdragm)
+c      call histwrite_phy(nid_mth,.false.,"cdrh",itau_w,cdragh)
+
       ENDIF !lev_histmth.GE.5
 c-------------------------------------------------------
-c
+
       if (ok_sync) then
         call histsync(nid_mth)
